<script setup>
import WebsiteItem from './WebsiteItem.vue'

import { onMounted, ref } from 'vue'

const data = ref(null)
const error = ref(null)

fetch ('https://api.mangaUpdate.fr/api/getWebsites', {
  method: 'POST',
  headers: {'Content-Type' : 'application/json'},
  body: JSON.stringify({
    'token':sessionStorage.getItem('authentificated')
  })
}).then((res) => res.json())
  .then((json) => {(data.value = json)})
  .catch((err) => (error.value = err))


  function update_voir_updates(e){
    let elm = e.target;
    let liste_div = document.getElementById('menu_voir_updates').lastElementChild;
    liste_div.setAttribute('class', 'flex flex-col overflow-y-scroll lg:grid lg:grid-cols-2 lg:gap-4 xl:grid-cols-3 2xl:grid-cols-4');
    liste_div.innerText = "";
    Array.from(data._rawValue[elm.getAttribute('data_index')].books).forEach(book => {
      let elm_liste_book = document.createElement('div');
      elm_liste_book.innerHTML = '<a href="'+book.link.replace('asura.gg', 'asuratoon.com')+'" target="_blank" class="flex items-center mb-4">\
                                    <img src="'+book.image.replace('asura.gg', 'asuratoon.com')+'" alt="image_livre" class="w-1/5 me-3">\
                                    <h3>'+book.nom+'</h3>\
                                  </a>'
      liste_div.appendChild(elm_liste_book);
    })
    fetch ('https://api.mangaUpdate.fr/api/website/updateNew', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id
      })
    }).then((res) => res.json())
      .then((json) => {console.log(json);})
      .catch((err) => (error.value = err))
    
  }

  function toggle_favorite(e){
    let elm = e.target.classList.contains('favorite_toggle') ? e.target : e.target.parentElement
    fetch ('https://api.mangaUpdate.fr/api/website/toggleFavorite', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id
      })
    }).then((res) => res.json())
      .then((json) => {json == 'website is favorite' ? data.value[elm.getAttribute('data_index')].favorite = true : json == 'website is not favorite' ? data.value[elm.getAttribute('data_index')].favorite = false : console.log(json); console.log(data);})
      .catch((err) => (error.value = err))
    
  }

  function delete_follow_website(e){
    let elm = e.target.classList.contains('delete_icon') ? e.target : e.target.parentElement
    fetch ('https://api.mangaUpdate.fr/api/website/removeFollowWebsite', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id
      })
    }).then((res) => res.json())
      .then((json) => location.reload())
      .catch((err) => (error.value = err))
  }

  let touch_position = [];
  let elm_position_initial = [];

  function init_touch_position(e){
    let website = e.target;
    while(!website.classList.contains('my_website')){
      website = website.parentElement;
    }
    touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')] = e.targetTouches[0].pageX;
    if(website.style.left == ''){
      website.style.left = '0px';
    }
    elm_position_initial[website.firstElementChild.lastElementChild.getAttribute('data_index')] = website.style.left.substring(0, website.style.left.length - 2);
  }

  function website_slide(e){
    let website = e.target;
    while(!website.classList.contains('my_website')){
      website = website.parentElement;
    }

    if(elm_position_initial[website.firstElementChild.lastElementChild.getAttribute('data_index')] == 0){
      if(e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')] <= 80 
        && e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')] > -100){   
          website.style.left = (e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')]) + 'px' ;
      }
    }else{
      if(e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')] <= 180
        && e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')] > -180){   
          website.style.left = parseInt(elm_position_initial[website.firstElementChild.lastElementChild.getAttribute('data_index')]) + (e.targetTouches[0].pageX - touch_position[website.firstElementChild.lastElementChild.getAttribute('data_index')]) + 'px' ;
      }
    }
  }

  function website_end_slide(e){
    let website = e.target;
    while(!website.classList.contains('my_website')){
      website = website.parentElement;
    }
    if(website.style.left.substring(0, website.style.left.length - 2) >= 60){
      website.style.left = 60 + 'px';
    }else if(website.style.left.substring(0, website.style.left.length - 2) <= -60){
      website.style.left = '-80px';
    }else{
      website.style.left = '0';
    }
  }

</script>

<template>
  <div id="liste_website" class="w-full">

    <div v-if="error" class="error">{{ error }}</div>

    <div v-else-if="data" class="content lg:grid lg:gap-2 lg:grid-cols-2 xl:grid-cols-3 2xl:grid-cold-4">
      <li class="list-none my_website" draggable="true" @touchmove="website_slide" @touchstart="init_touch_position"
        @touchend="website_end_slide" v-for="(website, index) in data">
        <WebsiteItem>
          <template #delete>
            <font-awesome-icon class="absolute h-8 my-0 mx-4 right-full delete_icon text-red-800 lg:hidden"
              icon="fa-solid fa-trash-can" v-bind:data_index="index" @click="delete_follow_website"/>
          </template>
          <template #name>
            <a v-bind:href=website.link target="_blank">
              <h2>
                {{ website.name }}
              </h2>
            </a>
          </template>
          <template #updates>
            <div class="flex items-center">
              <div class="flex justify-center items-center p-2 bg-zinc-400 ms-2 rounded">
                <label class="ouvrir_overlay_voir_update" for="voir_updates"
                  v-bind:data_index="index" @click="update_voir_updates">
                  {{ website.books.length > 0 ? '+'+website.books.length : '' }}
                </label>
              </div>
              <font-awesome-icon v-if="website.favorite" class="hidden h-8 my-0 mx-4 favorite_toggle lg:block"
                icon="fa-solid fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
              <font-awesome-icon v-else class="hidden h-8 my-0 mx-2 favorite_toggle lg:block"
                icon="fa-regular fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
              <font-awesome-icon class="hidden h-8 my-0 delete_icon text-red-800 lg:block"
                icon="fa-solid fa-trash-can" v-bind:data_index="index" @click="delete_follow_website"/>
            </div>
          </template>
          <template #favourite>
              <font-awesome-icon v-if="website.favorite" class="absolute h-10 my-0 mx-4 left-full favorite_toggle
                lg:hidden" icon="fa-solid fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
              <font-awesome-icon v-else class="absolute h-10 my-0 mx-4 left-full favorite_toggle lg:hidden"
                icon="fa-regular fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
          </template>
        </WebsiteItem>
      </li>
    </div>
    <div v-else="loading" class="loading">Loading...</div>
  </div>
</template>